<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Schwarzenegger!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>
    <section>
        <title>Szoftmax Py MNIST</title>
        <para>
            Python
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/H3QRcdqQcuk">https://youtu.be/H3QRcdqQcuk</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/szakacs.agi21/bhax/-/blob/master/thematic_tutorials/bhax_textbook/Schwarzenegger/8.1.py">8.1.py</link>                
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>
	<para>
	Mi az a MNIST?
	</para>
	<para>
	A MNIST egy olyan adatbázis ami tanitóanyagokat biztosít, például olyan hálózatok tanítására amiknek feladata, hogy háttértudások(tanult minták alapján) segítségével elemezni tudjanak bemeneti képeket. Az adatbázis kézzel írt arab számokat tartalmaz.
	</para>
	<para>
	Mi az a Tensorflow
	</para>
	<para>
	A Tensorflow egy nyílt forrású matematikai könyvtár amit a gépi tanulásban, például neurális hálózatoknál, használnak.
</para>
<para>
A program:
</para>
<programlisting language="Python"><![CDATA[
import tensorflow as tf #beimportáljuk a tensorflow libary-t

mnist = tf.keras.datasets.mnist #létrehozunk egy mnist objektumot amiben az adatokat tároljuk

(x_train, y_train), (x_test, y_test) = mnist.load_data() #betöltjük a datasetet a memóriánkban
x_train, x_test = x_train / 255.0, x_test / 255.0

model = tf.keras.models.Sequential([ #elkészítjük a gépi tanuló modellünket
  tf.keras.layers.Flatten(input_shape=(28, 28)),
  tf.keras.layers.Dense(128, activation='relu'),
  tf.keras.layers.Dropout(0.2),
  tf.keras.layers.Dense(10)
])

predictions = model(x_train[:1]).numpy() #ez adja a neurális hálónk kimenetelét
predictions

tf.nn.softmax(predictions).numpy() #a neurális háló kimenetelét transzformáljuk át osztályokká

loss_fn = tf.keras.losses.SparseCategoricalCrossentropy(from_logits=True)

loss_fn(y_train[:1], predictions).numpy()#kiíratjuk a loss_fn-t 

model.compile(optimizer='adam', loss=loss_fn,metrics=['accuracy']) #összeálítjuk a modellünket

model.fit(x_train, y_train, epochs=5) #a fit tanítja be a modellünket

model.evaluate(x_test,  y_test, verbose=2)#kiértékeljük a modellünket

probability_model = tf.keras.Sequential([
  model,
  tf.keras.layers.Softmax()
])

probability_model(x_test[:5]) #kiíratjuk a tesztünk eredményét
]]></programlisting>
<para>
A program kimenetele:
</para>
<mediaobject>
                <imageobject>
                    <imagedata fileref="Src/8_1.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>A program kimenetele</phrase>
                </textobject>
            </mediaobject>     
    </section>       
    <section>
        <title>Mély MNIST</title>
        <para>
            Python            
        </para>
        <para>
            Megoldás videó:<link xlink:href=""></link>
        </para>
        <para>
            Megoldás forrása:<link xlink:href=""></link>                
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>
	<caution>
            <title>Passzolás</title>
            <para>
                Az ötödik előadás passzolási lehetőségemet szeretném használni ennél a feladatnál. 
            </para>
        </caution>      
    </section>                        
              <section>
        <title>Minecraft-MALMÖ</title>
        <para>
            Most, hogy már van némi ágensprogramozási gyakorlatod, adj egy rövid általános áttekintést a MALMÖ projektről!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://www.youtube.com/watch?v=6YtfOEV7U54"></link>
        </para>
<para>
            Red Flower Hell: <link xlink:href="https://github.com/nbatfai/RedFlowerHell">https://github.com/nbatfai/RedFlowerHell</link>.      
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/szakacs.agi21/bhax/-/blob/master/thematic_tutorials/bhax_textbook/MALM%C3%96/rfh4_zsiraf_Norbi_%C3%81gi.cpp">rfh4_zsiraf_Norbi_Ági.cpp</link>                
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>
<para>
                A MALMÖ projekt egy Minecraft mod, amelyet a Microsoft hozott létre. Ezzel tudunk olyan programokat írni ami a játékban egy adott környezetben irányít egy vagy több ágenst.
            </para>
<para>
               A félév során lehetőségünk volt, versenyezni a Red Flower Hell nevű versenysorozatban. 
	       A verseny célja az, hogy minél több piros virágot gyűjtsünk, mielőtt a láva lefolyik a domboldalon.
            </para>
<para>
Ebben a félévben, négy versenysorozat volt: 
</para>
<itemizedlist>
            <listitem>
                <para>
                    Red Flower Hell I
                </para>
            </listitem>
            <listitem>
                <para>
                   Red Flower Hell II
                </para>
            </listitem>
<listitem>
                <para>
                    Red Flower Hell III
                </para>
            </listitem>
<listitem>
                <para>
                    Red Flower Hell IV
                </para>
            </listitem>
        </itemizedlist>
<para>
Én ezek közül csak az utlsó fordulón a RFH IV-en vettem rész, csapattársammal Fiedler Norberttel. 
</para>
<para>
A kódunk bejutott a RFHIV döntőjébe, ahol megosztott 3. helyezetett kapott.  
</para>
<para>
Három hétig írtuk a kódunkat amire nagyon büszke vagyok, és remélem, hogy jövőre lesz lehetőségünk tovább versenyezni a RFH-ben.   
</para>
<para>
Kép az arénáról:
</para>
<mediaobject>
                <imageobject>
                    <imagedata fileref="Src/RFHarena.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>A program kimenetele</phrase>
                </textobject>
            </mediaobject>     
    </section>        
    <section>
        <title>Vörös Pipacs Pokol/javíts a 19 RF-en</title>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/szakacs.agi21/bhax/-/blob/master/thematic_tutorials/bhax_textbook/MALM%C3%96/greenpill.cpp">greenpill.cpp</link>              
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para> 
            
    </section>                                      
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
</chapter>                
